# -*- coding: utf-8 -*-
import os, sys
import xbmcaddon
import traceback, urllib

if sys.version_info >= (2,7): import json as _json
else: import simplejson as _json

scriptID = 'plugin.video.polishtv.live'
scriptname = "Polish Live TV"
ptv = xbmcaddon.Addon(scriptID)

BASE_IMAGE_PATH = 'http://sd-xbmc.org/repository/xbmc-addons/'
BASE_RESOURCE_PATH = os.path.join( ptv.getAddonInfo('path'), "../resources" )
sys.path.append( os.path.join( BASE_RESOURCE_PATH, "lib" ) )

import sdLog, sdParser, sdCommon, sdNavigation, sdErrors

log = sdLog.pLog()

SERVICE = 'nadajemytv'
LOGOURL = BASE_IMAGE_PATH + SERVICE + '.png'
MAINURL = 'http://nadajemy.tv/api/api.php'

class nadajemytv:
    def __init__(self):
        log.info('Loading ' + SERVICE)
        self.parser = sdParser.Parser()
        self.exception = sdErrors.Exception()
        self.gui = sdNavigation.sdGUI()
        self.common = sdCommon.common()


    def listChannels(self):     
        query_data = { 'url': MAINURL + '?method=getChannels', 'use_host': False, 'use_cookie': False, 'use_post': False, 'return_data': True}
        
        try:
            data = self.common.getURLRequestData(query_data)
        except Exception, exception:
            traceback.print_exc()
            self.exception.getError(str(exception))
            exit()
            
        result = _json.loads(data)
        for item in result:
            params = {'service': SERVICE, 'name': 'playSelectedVideo', 'id': item['id'], 'title': item['id'], 'icon': item['image'], 'url': item['url']}
            self.gui.addDir(params)
        self.gui.endDir()


    def handleService(self):
        params = self.parser.getParams()
        name = str(self.parser.getParam(params, "name"))
        title = str(self.parser.getParam(params, "title"))
        url = str(self.parser.getParam(params, "url"))

        if name == 'None':
            self.listChannels()
        elif name == 'playSelectedVideo':
            self.common.LOAD_AND_PLAY_VIDEO(url, title)    
